/*
 *  Copyright (C) 2010-2012 Agrosense info@agrosense.eu
 * 
 *  Licensed under the Eclipse Public License - v 1.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 * 
 *           http://www.eclipse.org/legal/epl-v10.html
 * 
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package nl.cloudfarming.client.task.shape;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.List;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import nl.cloudfarming.client.field.shape.TreatmentZoneImportCookie;
import org.openide.awt.ActionID;
import org.openide.awt.ActionReference;
import org.openide.awt.ActionReferences;
import org.openide.awt.ActionRegistration;
import org.openide.util.NbBundle.Messages;

@ActionID(category = "Task", id = "nl.cloudfarming.client.task.shape.CreateTaskFromShapeAction")
@ActionRegistration(iconBase = "nl/cloudfarming/client/task/shape/clipboard_sign.png", displayName = "#CTL_CreateTaskFromShape")
@ActionReferences(value = {
    @ActionReference(path = "Loaders/application/x-esri-shape/Actions", position = 3000)})
@Messages({"CTL_CreateTaskFromShape=Convert to task"})
public final class CreateTaskFromShapeAction implements ActionListener {

    private final List<TreatmentZoneImportCookie> cookies;

    public CreateTaskFromShapeAction(List<TreatmentZoneImportCookie> cookies) {
        this.cookies = cookies;
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        ExecutorService executor = Executors.newFixedThreadPool(1);
        TaskCreator creator = new TaskCreator(cookies);
        executor.execute(creator);
        executor.shutdown();
    }
}
